image:
  name: gcr.io/kaniko-project/executor:debug
  entrypoint: [""]

stages:
  - build
  - test
  - release

variables:
  TEST_IMAGE: $CI_REGISTRY_IMAGE/$CI_COMMIT_REF_SLUG:$CI_COMMIT_SHORT_SHA
  RELEASE_IMAGE: $CI_REGISTRY_IMAGE:latest

build:
  stage: build
  script:
    - mkdir -p /kaniko/.docker
    - echo "{\"auths\":{\"$CI_REGISTRY\":{\"username\":\"$CI_REGISTRY_USER\",\"password\":\"$CI_REGISTRY_PASSWORD\"}}}" > /kaniko/.docker/config.json
    - /kaniko/executor --context $CI_PROJECT_DIR 
      --dockerfile $CI_PROJECT_DIR/Dockerfile 
      --build-arg BUILD_DATETIME=$(date -u +'%Y-%m-%dT%H:%M:%SZ') 
      --build-arg VCS_REF=${CI_COMMIT_SHORT_SHA} 
      --build-arg VCS_TIMESTAMP=${CI_COMMIT_TIMESTAMP} 
      --destination $TEST_IMAGE


release:
  stage: release
  script:
    - mkdir -p /kaniko/.docker
    - echo "{\"auths\":{\"$CI_REGISTRY\":{\"username\":\"$CI_REGISTRY_USER\",\"password\":\"$CI_REGISTRY_PASSWORD\"}}}" > /kaniko/.docker/config.json
    - echo "FROM  ${TEST_IMAGE}" | /kaniko/executor --context $CI_PROJECT_DIR --dockerfile /dev/stdin --destination ${RELEASE_IMAGE}
  only:
    - master

include:
  # Trivy integration with GitLab Container Scanning
  # - remote: "https://github.com/aquasecurity/trivy/raw/main/contrib/Trivy.gitlab-ci.yml"
  - template: Security/Container-Scanning.gitlab-ci.yml

container_scanning:
  variables:
    CS_DEFAULT_BRANCH_IMAGE: $CI_REGISTRY_IMAGE/$CI_DEFAULT_BRANCH:$CI_COMMIT_SHA
    DOCKER_IMAGE: $CI_REGISTRY_IMAGE/$CI_COMMIT_REF_SLUG:$CI_COMMIT_SHORT_SHA
    CS_DISABLE_DEPENDENCY_LIST: "true"
    CS_DISABLE_LANGUAGE_VULNERABILITY_SCAN: "false"

# Trivy_container_scanning:
#   variables:
#     IMAGE: $CI_REGISTRY_IMAGE/$CI_COMMIT_REF_SLUG:$CI_COMMIT_SHORT_SHA
#   artifacts:
#     paths: [gl-container-scanning-report.json]
#   script:
#     # Build report
#     - trivy --exit-code 0 --cache-dir .trivycache/ --no-progress --format template --template "@/tmp/trivy-gitlab.tpl" -o gl-container-scanning-report.json $IMAGE
#     # Print report
#     - trivy --exit-code 0 --cache-dir .trivycache/ --no-progress --severity HIGH $IMAGE
#     # Fail on severe vulnerabilities
#     - trivy --exit-code 1 --cache-dir .trivycache/ --severity CRITICAL --no-progress $IMAGE

